﻿Public Class ByteOfBits
    Public MyHex As String = "00"
    Public Event valuechanged()
    Private MyValue As Byte = 0
    Private MyB7 As Boolean = False
    Private MyB6 As Boolean = False
    Private MyB5 As Boolean = False
    Private MyB4 As Boolean = False
    Private MyB3 As Boolean = False
    Private MyB2 As Boolean = False
    Private MyB1 As Boolean = False
    Private MyB0 As Boolean = False

#Region "ClickHandlers"
    Private Sub B7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B7.Click
        MyB7 = Not MyB7
        UpdateByte()
    End Sub
    Private Sub B6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B6.Click
        MyB6 = Not MyB6
        UpdateByte()

    End Sub

    Private Sub B5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B5.Click
        MyB5 = Not MyB5
        UpdateByte()

    End Sub

    Private Sub B4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B4.Click
        MyB4 = Not MyB4
        UpdateByte()

    End Sub

    Private Sub B3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B3.Click
        MyB3 = Not MyB3
        UpdateByte()

    End Sub

    Private Sub B2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B2.Click
        MyB2 = Not MyB2
        UpdateByte()

    End Sub

    Private Sub B1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B1.Click
        MyB1 = Not MyB1
        UpdateByte()

    End Sub

    Private Sub B0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B0.Click
        MyB0 = Not MyB0
        UpdateByte()

    End Sub
#End Region

#Region "Private Routines"

    Private Sub UpdateByte()
        Dim MyOneColour As Color = Color.LightGreen
        Dim MyZeroColour As Color = Color.LightGray
        Dim Mytemp As String = ""
        MyValue = 0
        If MyB7 Then
            B7.BackColor = MyOneColour
            MyValue = MyValue + 128
        Else
            B7.BackColor = MyZeroColour
        End If
        If MyB6 Then
            B6.BackColor = MyOneColour
            MyValue = MyValue + 64
        Else
            B6.BackColor = MyZeroColour
        End If
        If MyB5 Then
            B5.BackColor = MyOneColour
            MyValue = MyValue + 32
        Else
            B5.BackColor = MyZeroColour
        End If
        If MyB4 Then
            B4.BackColor = MyOneColour
            MyValue = MyValue + 16
        Else
            B4.BackColor = MyZeroColour
        End If
        If MyB3 Then
            B3.BackColor = MyOneColour
            MyValue = MyValue + 8
        Else
            B3.BackColor = MyZeroColour
        End If
        If MyB2 Then
            B2.BackColor = MyOneColour
            MyValue = MyValue + 4
        Else
            B2.BackColor = MyZeroColour
        End If
        If MyB1 Then
            B1.BackColor = MyOneColour
            MyValue = MyValue + 2
        Else
            B1.BackColor = MyZeroColour
        End If
        If MyB0 Then
            B0.BackColor = MyOneColour
            MyValue = MyValue + 1
        Else
            B0.BackColor = MyZeroColour
        End If
        Mytemp = LCase(Hex(MyValue))
        If Len(Mytemp) < 2 Then Mytemp = "0" & Mytemp
        MyHex = Mytemp
        LabByteValue.Text = Mytemp
        RaiseEvent valuechanged()
    End Sub
#End Region

#Region "Public Routines"

    Public Sub UpdateValues(ByVal mynewB7 As Byte, ByVal mynewB6 As Byte, ByVal mynewB5 As Byte, ByVal mynewB4 As Byte, ByVal mynewB3 As Byte, ByVal mynewB2 As Byte, ByVal mynewB1 As Byte, ByVal mynewB0 As Byte)
        ' if value is 0 or 1 set to enabled and 0 or 1
        ' if value is 2 or 3 set to disabled and 0 or 1
        If mynewB7 > 1 Then
            B7.Enabled = False
            mynewB7 = mynewB7 - 2
        Else
            B7.Enabled = True
        End If
        If mynewB7 > 0 Then
            MyB7 = True
        Else
            MyB7 = False
        End If
        If mynewB6 > 1 Then
            B6.Enabled = False
            mynewB6 = mynewB6 - 2
        Else
            B6.Enabled = True
        End If
        If mynewB6 > 0 Then
            MyB6 = True
        Else
            MyB6 = False
        End If
        If mynewB5 > 1 Then
            B5.Enabled = False
            mynewB5 = mynewB5 - 2
        Else
            B5.Enabled = True
        End If
        If mynewB5 > 0 Then
            MyB5 = True
        Else
            MyB5 = False
        End If
        If mynewB4 > 1 Then
            B4.Enabled = False
            mynewB4 = mynewB4 - 2
        Else
            B4.Enabled = True
        End If
        If mynewB4 > 0 Then
            MyB4 = True
        Else
            MyB4 = False
        End If
        If mynewB3 > 1 Then
            B3.Enabled = False
            mynewB3 = mynewB3 - 2
        Else
            B3.Enabled = True
        End If
        If mynewB3 > 0 Then
            MyB3 = True
        Else
            MyB3 = False
        End If
        If mynewB2 > 1 Then
            B2.Enabled = False
            mynewB2 = mynewB2 - 2
        Else
            B2.Enabled = True
        End If
        If mynewB2 > 0 Then
            MyB2 = True
        Else
            MyB2 = False
        End If
        If mynewB1 > 1 Then
            B1.Enabled = False
            mynewB1 = mynewB1 - 2
        Else
            B1.Enabled = True
        End If
        If mynewB1 > 0 Then
            MyB1 = True
        Else
            MyB1 = False
        End If
        If mynewB0 > 1 Then
            B0.Enabled = False
            mynewB0 = mynewB0 - 2
        Else
            B0.Enabled = True
        End If
        If mynewB0 > 0 Then
            MyB0 = True
        Else
            MyB0 = False
        End If

        UpdateByte()
    End Sub
    Public Sub UpdateLabels(ByVal Bytename As String, ByVal B7Name As String, ByVal B6Name As String, ByVal B5Name As String, ByVal B4Name As String, ByVal B3Name As String, ByVal B2Name As String, ByVal B1Name As String, ByVal B0Name As String)
        Byte1.Text = Bytename
        B7.Text = B7Name
        B6.Text = B6Name
        B5.Text = B5Name
        B4.Text = B4Name
        B3.Text = B3Name
        B2.Text = B2Name
        B1.Text = B1Name
        B0.Text = B0Name
    End Sub
#End Region

End Class
